Невозможно установить Docker на Ubuntu после r незапланированного выключения - proUbuntu
1 голос
/ 09 августа 2020

Это мой первый вопрос, поэтому я надеюсь, что задаю правильный путь. Я запускаю docker внутри виртуальной машины VirtualBox (гостевая ОС - Ubuntu 18.04)

bink@bink-VirtualBox:~$ lsb_release -a
No LSB modules are available.
Distributor ID: Ubuntu
Description:    Ubuntu 18.04.4 LTS
Release:    18.04
Codename:   bionic

В другой r день у меня была «незапланированная перезагрузка» (например, сбой r), Должно быть, были повреждены некоторые файлы, так как служба docker не запускается долго r. Я попытался отремонтировать и исправить docker, и в конечном итоге удалил docker в соответствии с инструкциями на Как полностью удалить docker.

После r я переустановил docker с нуля, используя стандартные инструкции https://docs.docker.com/engine/install/ubuntu/.

На последнем этапе установки я получаю несколько ошибок, см. Здесь:

bink@bink-VirtualBox:/var/lib$ sudo apt-get install docker-ce docker-ce-cli containerd.io
Reading package lists... Done
Building dependency tree       
Reading state information... Done
containerd.io is already the newest version (1.2.13-2).
The following additional packages will be installed:
  aufs-tools cgroupfs-mount pigz
The following NEW packages will be installed:
  aufs-tools cgroupfs-mount docker-ce docker-ce-cli pigz
0 upgraded, 5 newly installed, 0 to remove and 27 not upgraded.
Need to get 63.8 kB/63.9 MB of archives.
After this operation, 282 MB of additional disk space will be used.
Do you want to continue? [Y/n] y
Get:1 http://us.archive.ubuntu.com/ubuntu bionic/universe amd64 pigz amd64 2.4-1 [57.4 kB]
Get:2 http://us.archive.ubuntu.com/ubuntu bionic/universe amd64 cgroupfs-mount all 1.4 [6,320 B]
Fetched 63.8 kB in 0s (268 kB/s)          
Selecting previously unselected package pigz.
(Reading database ... 186105 files and directories currently installed.)
Preparing to unpack .../archives/pigz_2.4-1_amd64.deb ...
Unpacking pigz (2.4-1) ...
Selecting previously unselected package aufs-tools.
Preparing to unpack .../aufs-tools_1%3a4.9+20170918-1ubuntu1_amd64.deb ...
Unpacking aufs-tools (1:4.9+20170918-1ubuntu1) ...
Selecting previously unselected package cgroupfs-mount.
Preparing to unpack .../cgroupfs-mount_1.4_all.deb ...
Unpacking cgroupfs-mount (1.4) ...
Selecting previously unselected package docker-ce-cli.
Preparing to unpack .../docker-ce-cli_5%3a19.03.12~3-0~ubuntu-bionic_amd64.deb ...
Unpacking docker-ce-cli (5:19.03.12~3-0~ubuntu-bionic) ...
Selecting previously unselected package docker-ce.
Preparing to unpack .../docker-ce_5%3a19.03.12~3-0~ubuntu-bionic_amd64.deb ...
Unpacking docker-ce (5:19.03.12~3-0~ubuntu-bionic) ...
Setting up aufs-tools (1:4.9+20170918-1ubuntu1) ...
Setting up cgroupfs-mount (1.4) ...
Setting up docker-ce-cli (5:19.03.12~3-0~ubuntu-bionic) ...
Setting up pigz (2.4-1) ...
Setting up docker-ce (5:19.03.12~3-0~ubuntu-bionic) ...
Created symlink /etc/systemd/system/multi-user.target.wants/docker.service → /lib/systemd/system/docker.service.
Created symlink /etc/systemd/system/sockets.target.wants/docker.socket → /lib/systemd/system/docker.socket.
Job for docker.service canceled.
invoke-rc.d: initscript docker, action "start" failed.
● docker.service - Docker Application Container Engine
   Loaded: loaded (/lib/systemd/system/docker.service; enabled; vendor preset: enabled)
   Active: deactivating (stop-sigterm)
     Docs: https://docs.docker.com
 Main PID: 23326 (dockerd)
    Tasks: 1
   CGroup: /system.slice/docker.service
           └─23326 [dockerd]

Aug 09 13:10:56 bink-VirtualBox systemd[1]: Starting Docker Application Container Engine...
dpkg: error processing package docker-ce (--configure):
 installed docker-ce package post-installation script subprocess returned error exit status 1
Processing triggers for libc-bin (2.27-3ubuntu1.2) ...
Processing triggers for systemd (237-3ubuntu10.41) ...
Processing triggers for man-db (2.8.3-2ubuntu0.1) ...
Processing triggers for ureadahead (0.100.0-21) ...
Errors were encountered while processing:
 docker-ce
E: Sub-process /usr/bin/dpkg returned an error code (1)

Я подозреваю, что при незапланированной перезагрузке что-то случилось с containerd.io, но когда я запускаю docker install, он говорит, что containerd.io уже является последней версией, поэтому переустанавливать его не нужно. *

Если я попробую systemctl start docker, он просто вернет Job for docker.service canceled.. Но я действительно могу запустить sudo dockerd, и docker запустится. Я просто не могу запустить его как службу.

Есть ли у кого-нибудь предложения? Я искал r этих ошибок и нашел несколько похожих результатов r, но не совсем ту же ситуацию, что и я. Мне просто нужно переустановить containerd.io? И если да, то как мне это сделать, если система считает, что он уже установлен правильно?

1 Ответ

0 голосов
/ 09 августа 2020

Чтобы выяснить, что не так со службой Docker, может помочь вывод systemctl status docker.service o r journalctl -e. Попробуйте эти команды сразу после r a systemctl start docker.service.

Чтобы переустановить пакет, используйте sudo apt --reinstall install containerd.io o r simila r. Это объясняется здесь .

Но я бы попытался найти причину root того, почему служба не запускается. Он может исправить и другие r вещи, и вы узнаете из него больше ?.

...